#ifndef VVTK_SDK_AVCOMPOSER_DEFINE_H
#define VVTK_SDK_AVCOMPOSER_DEFINE_H

#include "typedef.h"
#include "errordef.h"

typedef struct t_oceanus_timepoint
{
	/** \brief the second part of the time.
	 */
	DWORD	dwTimeInSecond;

	/** \brief the millisecond part of the time.	 
	 */
	DWORD	dwMilliSecond;
} TAVCOMPOSER_TIMEPOINT;

/*
	This structure is for reporting the file information when calling StopRecording or pfGetNewFilename()
*/
typedef struct t_oceanus_close_file_info
{
	WORD wSize;
	DWORD dwFileSize;				//	Filesize in bytes
	TAVCOMPOSER_TIMEPOINT tStartTime;	//	The file start time 
	TAVCOMPOSER_TIMEPOINT tEndTime;	//	The file end time 
	BOOL bCreatedMediaFile;			//	Indicate if the media file is created.	
} TAVCOMPOSER_CLOSEFILEINFO;

//	TrackID List
typedef enum
{
	eAVComposerTrack1,
	eAVComposerTrack2,
	eAVComposerTrack3,
	eAVComposerTrack4,
	eAVComposerTrack5,
	eAVComposerTrack6,
	eAVComposerTrack7,
	eAVComposerTrack8,
	eAVComposerTrack9,
	eAVComposerTrack10,
	eAVComposerTrack11,
	eAVComposerTrack12,
	EAVCOMPOSER_NUM_TRACKS
} EAVCOMPOSER_TRACK_TYPE;

typedef SCODE (__stdcall * AVCOMPOSER_PF_REQUEST_FILENAME)(HANDLE hContext, char *pszNewFilename, TAVCOMPOSER_CLOSEFILEINFO *ptCurFileInfo);

typedef SCODE (__stdcall * AVCOMPOSER_PF_REQUEST_FILENAMEW)(HANDLE hContext, wchar_t *pszNewFilename, TAVCOMPOSER_CLOSEFILEINFO *ptCurFileInfo);

typedef enum
{
	eRecOptVivoTrack		= 1,
	eRecOptNoViewWhileRec	= 1 << 1, // meaningful only when vivotrack is enable
	eRecOptNoBuffering		= 1 << 2, // flush immediately
} EAVCOMPOSER_RECORD_OPTIONS;

#endif	// VVTK_SDK_AVCOMPOSER_DEFINE_H
