/*!
 *******************************************************************************
 * Copyright 2006-2010 Vivotek, Inc. All rights reserved.
 *
 * \file
 * VersionHelper.h
 *
 * \brief
 * Header file of Version Helper. 
 *
 *
 * \date
 * 2007/01/10
 *
 * \author
 * Diro
 *
 *
 *******************************************************************************
 */

#ifndef _VERSION_HELPER_H_
#define  _VERSION_HELPER_H_

#include <assert.h>
#include "typedef.h"

/** \brief This structure is used to store the verison information
 *
 */
typedef struct t_version_info
{
	WORD wMajor;
	WORD wMinor;
	WORD wBuild;
	WORD wRevision;
} TVERSION_INFO;

#define VH_VERSION_MAJOR(PROJECTNAME)			PROJECTNAME##_VERSION_MAJOR
#define VH_VERSION_MINOR(PROJECTNAME)			PROJECTNAME##_VERSION_MINOR
#define VH_VERSION_BUILD(PROJECTNAME)			PROJECTNAME##_VERSION_BUILD
#define VH_VERSION_REVISION(PROJECTNAME)		PROJECTNAME##_VERSION_REVISION

#define VH_INIT_VERINFO_PTR(PROJECTNAME, VER_POINTER)				\
	assert(NULL != VER_POINTER);									\
	if (NULL != VER_POINTER)										\
	{																\
		VER_POINTER->wMajor = VH_VERSION_MAJOR(PROJECTNAME);		\
		VER_POINTER->wMinor = VH_VERSION_MINOR(PROJECTNAME);		\
		VER_POINTER->wBuild = VH_VERSION_BUILD(PROJECTNAME);		\
		VER_POINTER->wRevision = VH_VERSION_REVISION(PROJECTNAME);\
	}																\

#define VH_INIT_VERINFO_SCT(PROJECTNAME, VER_STRUCT)				\
{																	\
	TVERSION_INFO *ptVerInfo = &##VER_STRUCT;						\
	VH_INIT_VERINFO_PTR(PROJECTNAME, ptVerInfo);					\
}																	\

#define	VH_IS_VALID_VER_PTR(PROJECTNAME, VER_POINTER)				\
	!(((VER_POINTER->wMajor != VH_VERSION_MAJOR(PROJECTNAME)) ||	\
	 (VER_POINTER->wMinor > VH_VERSION_MINOR(PROJECTNAME))))		\

#define	VH_IS_VALID_VER_SCT(PROJECTNAME, VER_STRUCT)				\
	!(((VER_STRUCT.wMajor != VH_VERSION_MAJOR(PROJECTNAME)) ||	\
	 (VER_STRUCT.wMinor > VH_VERSION_MINOR(PROJECTNAME))))		\

#define VH_SHOW_VERINFO(PROJECTNAME)								\
	printf("%u.%u.%u.%u\n", VH_VERSION_MAJOR(PROJECTNAME),			\
							VH_VERSION_MINOR(PROJECTNAME),			\
							VH_VERSION_BUILD(PROJECTNAME),			\
							VH_VERSION_REVISION(PROJECTNAME));		\

#endif	// _VERSION_HELPER_H_