/************************************************************************
*                                                                       *
*   mainprofile_error.h --  error code definitions for mainprofile      *
*                                                                       *
*   Copyright (c) Vivotek Corp.  All rights reserved.                   *
*                                                                       *
************************************************************************/

#ifndef _MAINPROFILE_ERROR_
#define _MAINPROFILE_ERROR_

// Severity code 6

//--------------------------------------------------------------------------------
// Data Broker Error Codes
//--------------------------------------------------------------------------------
#define DATABROKER_E_FIRST 0x80060000
#define DATABROKER_E_LAST  0x800600FF
#define DATABROKER_S_FIRST 0x00060000
#define DATABROKER_S_LAST  0x000600FF

#define DATABROKER_S_OK								S_OK                // 0x00000000

#define DATABROKER_E_FAIL							S_FAIL              // 0xFFFFFFFF (-1)
#define DATABROKER_E_INVALID_HANDLE					ERR_INVALID_HANDLE	// 0x80000001
#define DATABROKER_E_OUT_OF_MEMORY					ERR_OUT_OF_MEMORY	// 0x80000002
#define DATABROKER_E_INVALID_ARG					ERR_INVALID_ARG		// 0x80000003

#define DATABROKER_E_TOO_MANY_CONNECTIONS			MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 1)
#define DATABROKER_E_RUNNINGCONNECTION				MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 2)
#define DATABROKER_E_NOSETTING						MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 3)
#define DATABROKER_E_WRONG_CONNECTION_SETTING		MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 4)
#define DATABROKER_E_HTTP_READ_ERROR				MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 5)
#define DATABROKER_E_HTTP_CONNECT_FAILED			MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 6)
#define DATABROKER_E_CONTROL_CHANNEL_CONNECT_FAILED	MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 7)
#define DATABROKER_E_INVALID_ID						MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 8)
#define	DATABROKER_E_CONTROL_CHAN_VER				MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 9)
#define	DATABROKER_E_QUEUE_FULL						MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 10)
#define	DATABROKER_E_PACKET_TOO_LARGE				MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 11)
#define	DATABROKER_E_CR_HTTP_SOCKET					MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 12)
#define	DATABROKER_E_HTTP_SEND_ERROR				MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 13)
#define DATABROKER_E_ACCESS_NAME_ERROR				MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 14)
#define DATABROKER_E_TUNNEL_FAILED					MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 15)
#define DATABROKER_E_RES_INSUFFICIENT				MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 16)
#define DATABROKER_E_NO_VIDEOCHARACTER				MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 17)
#define DATABROKER_E_CONNECTION_REFUSE				MAKE_SCODE (1, 6, DATABROKER_E_FIRST + 18)

#define DATABROKER_S_STOPCONNECTION					MAKE_SCODE (0, 6, DATABROKER_S_FIRST + 1)
#define DATABROKER_S_FRAME_NOT_HANDLED				MAKE_SCODE (0, 6, DATABROKER_S_FIRST + 2)
#define DATABROKER_S_NOMORE_CALLBACK				MAKE_SCODE (0, 6, DATABROKER_S_FIRST + 3)

//--------------------------------------------------------------------------------
// AV Synchronizer Error Codes
//--------------------------------------------------------------------------------
#define AVSYNCHRONIZER_E_FIRST 0x80060100
#define AVSYNCHRONIZER_E_LAST  0x800601FF
#define AVSYNCHRONIZER_S_FIRST 0x00060100
#define AVSYNCHRONIZER_S_LAST  0x000601FF

#define AVSYNCHRONIZER_S_OK                         S_OK                // 0x00000000
// when this is return, the module will ignore audio input
#define AVSYNCHRONIZER_S_NO_AUDIO_PLAY              MAKE_SCODE (0, 6, AVSYNCHRONIZER_S_FIRST + 1)
// when caption callback in audio only mode, the return value tell
// AVSynchronizer if the content is meaningful or not
#define AVSYNCHRONIZER_S_NO_CONTENT					MAKE_SCODE (0, 6, AVSYNCHRONIZER_S_FIRST + 2)
#define AVSYNCHRONIZER_S_NO_BORDER					MAKE_SCODE (0, 6, AVSYNCHRONIZER_S_FIRST + 3)
#define	AVSYNCHRONIZER_S_REINIT_VIDEO				MAKE_SCODE (0, 6, AVSYNCHRONIZER_S_FIRST + 4)
#define AVSYNCHRONIZER_S_ALREADY_DELETE             MAKE_SCODE (0, 6, AVSYNCHRONIZER_S_FIRST + 5)

#define AVSYNCHRONIZER_E_FAIL                       S_FAIL              // 0xFFFFFFFF (-1)
#define AVSYNCHRONIZER_E_INVALID_HANDLE             ERR_INVALID_HANDLE	// 0x80000001
#define AVSYNCHRONIZER_E_OUT_OF_MEMORY              ERR_OUT_OF_MEMORY	// 0x80000002
#define AVSYNCHRONIZER_E_INVALID_ARG                ERR_INVALID_ARG		// 0x80000003
#define AVSYNCHRONIZER_E_NOT_IMPLEMENT              ERR_NOT_IMPLEMENT   // 0x80000004
#define AVSYNCHRONIZER_E_INVALID_VERSION			ERR_INVALID_VERSION // 0x80000005

#define AVSYNCHRONIZER_E_CREATE_THREAD_FAILED       MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 1)
#define AVSYNCHRONIZER_E_CREATE_EVENT_FAILED        MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 2)
#define AVSYNCHRONIZER_E_INIT_VIDEO_FAILED          MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 3)
#define AVSYNCHRONIZER_E_INIT_AUDIO_FAILED          MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 4)
#define AVSYNCHRONIZER_E_INIT_DISPLAYMODE_FAILED    MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 5)
#define AVSYNCHRONIZER_E_INIT_SURFACE_FAILED        MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 6)
#define AVSYNCHRONIZER_E_UNKNOWN_MEDIATYPE          MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 7)
#define AVSYNCHRONIZER_E_CHANNEL_EXCEEDED           MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 8)
#define AVSYNCHRONIZER_E_CHANNEL_NOT_FOUND          MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 9)
#define AVSYNCHRONIZER_E_INVALID_DATA               MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 10)
#define AVSYNCHRONIZER_E_FRAME_DROPPED              MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 11)
#define AVSYNCHRONIZER_E_QUEUE_FULL					MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 12)
#define AVSYNCHRONIZER_E_SURFACE_LOST				MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 14)
#define AVSYNCHRONIZER_E_DECODE_ERROR				MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 15)
#define AVSYNCHRONIZER_E_SURFACE_RECOVERED			MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 16)
#define AVSYNCHRONIZER_E_DECODER_CHANNEL_ONLY		MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 17)
#define AVSYNCHRONIZER_E_MEDIA_TYPE_NEEDED			MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 18)
#define AVSYNCHRONIZER_E_NOT_APPLICABLE				MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 19)
#define	AVSYNCHRONIZER_E_NOMORE_FRAME				MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 20)
#define AVSYNCHRONIZER_E_NO_DDHARDWARE              MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 21)
#define AVSYNCHRONIZER_E_UNSUPPORTED_PIXELFORMAT    MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 22)
#define AVSYNCHRONIZER_E_DETECTHARDWARE_FAIL        MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 23)
#define AVSYNCHRONIZER_E_COULDNT_SWITCH_TWOPASS     MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 24)
#define AVSYNCHRONIZER_E_INVALID_FILENAME           MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 25)
#define	AVSYNCHRONIZER_E_REDO						MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 26)
#define	AVSYNCHRONIZER_E_CHANNEL_STOPPED			MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 27)
#define	AVSYNCHRONIZER_E_OPEN_AVI_FILE				MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 28)
#define	AVSYNCHRONIZER_E_CREATE_AVI_V_STREAM		MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 29)
#define	AVSYNCHRONIZER_E_CREATE_AVI_A_STREAM		MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 30)
#define	AVSYNCHRONIZER_E_ENCODE_AVI_VIDEO			MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 31)
#define	AVSYNCHRONIZER_E_ENCODE_AVI_AUDIO			MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 32)
#define	AVSYNCHRONIZER_E_WRITE_AVI_FILE				MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 33)
#define	AVSYNCHRONIZER_E_AVI_FILE_NOT_CREATED		MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 34)
#define	AVSYNCHRONIZER_E_CODEC_NOT_SUPPORTED		MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 35)
#define	AVSYNCHRONIZER_E_BUFFER_SIZE_NOTENOUGH		MAKE_SCODE (1, 6, AVSYNCHRONIZER_E_FIRST + 36)

//--------------------------------------------------------------------------------
// Packet Maker
//--------------------------------------------------------------------------------
#define PACKETMAKER_E_FIRST 0x80060200
#define PACKETMAKER_E_LAST  0x800602FF
#define PACKETMAKER_S_FIRST 0x00060200
#define PACKETMAKER_S_LAST  0x000602FF

#define PACKETMAKER_E_CHANNEL_EXCEEDED				MAKE_SCODE (1, 6, PACKETMAKER_E_FIRST + 1)
#define PACKETMAKER_E_OUT_OF_MEMORY			        MAKE_SCODE (1, 6, PACKETMAKER_E_FIRST + 2)
#define PACKETMAKER_E_CHANNEL_NOT_FOUND				MAKE_SCODE (1, 6, PACKETMAKER_E_FIRST + 3)
#define PACKETMAKER_E_HEADER_BUFFER_NOTENOUGH       MAKE_SCODE (1, 6, PACKETMAKER_E_FIRST + 4)
#define PACKETMAKER_E_INIT_AUDIOIN					MAKE_SCODE (1, 6, PACKETMAKER_E_FIRST + 5)

//--------------------------------------------------------------------------------
// Server Utility Error Codes
//--------------------------------------------------------------------------------
#define SERVUTL_E_FIRST 0x80060300
#define SERVUTL_E_LAST  0x800603FF
#define SERVUTL_S_FIRST 0x00060300
#define SERVUTL_S_LAST  0x000603FF

#define SERVUTL_E_OUT_OF_MEMORY					ERR_OUT_OF_MEMORY	// 0x80000002
#define SERVUTL_E_INVALID_HANDLE				ERR_INVALID_HANDLE	// 0x80000001
#define SERVUTL_E_INVALID_ARG					ERR_INVALID_ARG		// 0x80000003
#define SERVUTL_E_INVALID_VERSION				ERR_INVALID_VERSION // 0x80000005

#define SERVUTL_E_AUTH					MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 1)
#define SERVUTL_E_TOUT					MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 2)
#define SERVUTL_E_TOOMANY_ASYNC			MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 3)
#define SERVUTL_E_NO_MORE_FREEDEVICE	MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 4)
#define SERVUTL_E_OPER_NOTAVA			MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 5)
#define SERVUTL_E_NOPENDING_REQ			MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 6)
#define SERVUTL_E_UNKNOWN_SERVER		MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 7)
#define SERVUTL_E_OPEN_FILE				MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 8)
#define SERVUTL_E_TOMANY_CONFIG_ITEMS	MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 9)
#define SERVUTL_E_NO_MATCH_ITEM			MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 10)
#define	SERVUTL_E_UNKNOWN_FILETYPE		MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 11)
#define	SERVUTL_E_WRITE_FILE			MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 12)
#define	SERVUTL_E_FILE_CORRUPTED		MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 13)
#define	SERVUTL_E_INVALID_DIRECTORY		MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 14)
#define	SERVUTL_E_INVALID_LANGUAGE		MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 15)
#define	SERVUTL_E_READ_FILE				MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 16)
#define	SERVUTL_E_CREATE_SOCKET			MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 17)
#define	SERVUTL_E_SOCKET_OPT			MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 18)
#define	SERVUTL_E_SOCKET_ERROR			MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 19)
#define	SERVUTL_E_ABORTED				MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 20)
#define	SERVUTL_E_NO_SUCH_ENTRY			MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 21)
#define	SERVUTL_E_INVALID_FORMAT		MAKE_SCODE (1, 6, SERVUTL_E_FIRST + 22)

#define SERVUTL_S_BUFFER_SIZE			(SERVUTL_S_FIRST + 1)
//--------------------------------------------------------------------------------
// Srvdepresource  Error Codes
//--------------------------------------------------------------------------------
#define SRVDEPRESOURCE_E_FIRST 0x80060400
#define SRVDEPRESOURCE_E_LAST  0x800604FF
#define SRVDEPRESOURCE_S_FIRST 0x00060400
#define SRVDEPRESOURCE_S_LAST  0x000604FF

#define SRVDEPRESOURCE_S_PARTIAL_MATCH  MAKE_SCODE (0, 6, SRVDEPRESOURCE_S_FIRST)


//--------------------------------------------------------------------------------
// parsedatapacket  Error Codes
//--------------------------------------------------------------------------------
#define PARSEDATAPACKET_E_FIRST 0x80060500
#define PARSEDATAPACKET_E_LAST  0x800605FF
#define PARSEDATAPACKET_S_FIRST 0x00060500
#define PARSEDATAPACKET_S_LAST  0x000605FF

#define PARSEDATAPACKET_E_BUFFER_NOT_ENOUGH  MAKE_SCODE (0, 6, PARSEDATAPACKET_E_FIRST)

#endif 
