// ConvertAviDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ConvertAvi.h"
#include "ConvertAviDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#include "datapacketdef.h"
#include "parsedatapacket.h"
#include "AvSyncConvertAviWrapper.h"
#include "DataPacketParser.h"

#define MAX_PLAYSPEED_COUNT    3    // Max count of multiples/divisors of play speed
#define TIMESTAMP_BUF_SIZE     200  // Timestamp buffer size
#define PATHBUF_SIZE           MAX_PATH  // Max size of decode directory path buffer
#define DEFAULT_AVIFRAMERATE   15   // Default frame rate of AVI file
#define DEFAULT_AVIFRAMEWIDTH  0    // Default frame width of AVI file
#define DEFAULT_AVIFRAMEHEIGHT 0    // Default frame height of AVI file


DWORD WINAPI ReadRawFileThread(LPVOID lpParam);  // Read raw file thread 

SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2);     // AvSynchronizer Status callback function
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo);                           // AvSynchronizer Display callback function
SCODE __stdcall AvSynchronizerAviStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2);  // AvSynchronizer AVI Status callback function
SCODE __stdcall AvSynchronizerAviCaptionCallBack(DWORD dwContext, TDISPLAYINFO* ptCaptionInfo);                        // AvSynchronizer AVI Caption callback function


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CConvertAviDlg dialog




CConvertAviDlg::CConvertAviDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConvertAviDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CConvertAviDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_FILEPATH, m_editboxFilePath);
	DDX_Control(pDX, IDC_BUTTON_PLAY, m_buttonPlay);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_buttonStop);
	DDX_Control(pDX, IDC_EDIT_SAVEAVIFILELOCATION, m_editboxSaveAviFileLocation);
	DDX_Control(pDX, IDC_BUTTON_SETUPSAVEAVIFILELOCATION, m_buttonSetupSaveAviFileLocation);
	DDX_Control(pDX, IDC_BUTTON_VIDEOCOMPRESSOR, m_buttonVideocompressor);
	DDX_Control(pDX, IDC_BUTTON_AUDIOCOMPRESSOR, m_buttonAudiocompressor);
}

BEGIN_MESSAGE_MAP(CConvertAviDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_OPENFILE, &CConvertAviDlg::OnBnClickedButtonOpenfile)
	ON_BN_CLICKED(IDC_BUTTON_PLAY, &CConvertAviDlg::OnBnClickedButtonPlay)
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CConvertAviDlg::OnBnClickedButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_SETUPSAVEAVIFILELOCATION, &CConvertAviDlg::OnBnClickedButtonSetupsaveavifilelocation)
	
	ON_MESSAGE(WM_USER_RESETDLGBUTTON, &CConvertAviDlg::OnResetDlgButton)  // Specific message map : WM_USER_RESETDLGBUTTON -> OnResetDlgButton
	ON_BN_CLICKED(IDC_BUTTON_VIDEOCOMPRESSOR, &CConvertAviDlg::OnBnClickedButtonVideocompressor)
	ON_BN_CLICKED(IDC_BUTTON_AUDIOCOMPRESSOR, &CConvertAviDlg::OnBnClickedButtonAudiocompressor)
END_MESSAGE_MAP()


// CConvertAviDlg message handlers

BOOL CConvertAviDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Initialization (Appended)
	//
	m_bStop  = FALSE;

	m_pszSaveDirectoryPath = new char [PATHBUF_SIZE];
	
	memset(m_pszSaveDirectoryPath, 0, PATHBUF_SIZE);
	
	m_hDisplay = GetDlgItem(IDC_STATIC_DISPLAY)->GetSafeHwnd();

	m_hBMP = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_MARK));

	m_hReadRawFileThread = NULL;
	
	// Construct a CAvSyncConvertAviWrapper object
	m_pAVWrapper = new CAvSyncConvertAviWrapper(this->GetSafeHwnd(), m_hDisplay, m_hBMP, AvSynchronizerStatusCallBack, 
		                                                                                 AvSynchronizerDisplayCallBack,
																						 AvSynchronizerAviStatusCallBack,
																						 AvSynchronizerAviCaptionCallBack,
																						 (DWORD)this,
																						 (DWORD)this,
																						 (DWORD)this,
																						 (DWORD)this);

	m_buttonPlay.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CConvertAviDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CConvertAviDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CConvertAviDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CConvertAviDlg::OnDestroy()
{
	if	(m_hReadRawFileThread != NULL)
	{	
		if	(!m_bStop)
		{	
			m_bStop = TRUE;

			// Wait for the "ReadRawFileThread"
			WaitForSingleObject(m_hReadRawFileThread, INFINITE);
		}

		// Close thread handle
		CloseHandle(m_hReadRawFileThread);
	}
	
	delete m_pAVWrapper;  // Destroy the CAvSyncConvertAviWrapper object

	if	(m_hDisplay != NULL)
	{
		::DestroyWindow(m_hDisplay);
	}

	if	(m_hBMP != NULL)
	{
		::DeleteObject(m_hBMP);
	}

	delete [] m_pszSaveDirectoryPath;
	
	CDialog::OnDestroy();
}

void CConvertAviDlg::OnBnClickedButtonOpenfile()
{
	char szFileFilter[] = "All Files (*.*)|*.*||";
	
	CFileDialog fDlg(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFileFilter);

	if	(fDlg.DoModal() == IDOK)
	{
		m_strFilePath = fDlg.GetPathName();

		m_editboxFilePath.SetWindowText(m_strFilePath.GetBuffer());

		m_buttonPlay.EnableWindow(TRUE);
	}
}

void CConvertAviDlg::OnBnClickedButtonPlay()
{
	UpdateData(TRUE);

	SCODE scRet;

	// Start AVI channel
	scRet = m_pAVWrapper->StartAVIChannel(m_pszSaveDirectoryPath);

	if	(scRet != S_OK)
	{
		return;
	}
	
	scRet = m_pAVWrapper->Play();  // Play

	if	(scRet != S_OK)
	{
		return;
	}

	m_bStop = FALSE;

	m_hReadRawFileThread = CreateThread(NULL, 0, ReadRawFileThread, this, 0, &m_dwThreadID);  // Start "ReadRawFileThread"
	
	m_buttonPlay.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(TRUE);
	m_buttonSetupSaveAviFileLocation.EnableWindow(FALSE);
	m_buttonVideocompressor.EnableWindow(FALSE);
	m_buttonAudiocompressor.EnableWindow(FALSE);
}

void CConvertAviDlg::OnBnClickedButtonStop()
{
	m_buttonStop.EnableWindow(FALSE);	
	m_buttonPlay.EnableWindow(TRUE);
	m_buttonSetupSaveAviFileLocation.EnableWindow(TRUE);
	m_buttonVideocompressor.EnableWindow(TRUE);
	m_buttonAudiocompressor.EnableWindow(TRUE);

	m_bStop = TRUE;

	m_pAVWrapper->Stop();  // Stop

	if	(m_hReadRawFileThread)
	{
		// Wait for the "ReadRawFileThread"
		WaitForSingleObject(m_hReadRawFileThread, INFINITE);
	}
}

void CConvertAviDlg::OnBnClickedButtonVideocompressor()
{
	m_pAVWrapper->SetVideoCompressorParam();
}

void CConvertAviDlg::OnBnClickedButtonAudiocompressor()
{
	m_pAVWrapper->SetAudioCompressorParam();
}

void CConvertAviDlg::OnBnClickedButtonSetupsaveavifilelocation()
{
	char szDirectoryPath[PATHBUF_SIZE] = "\0";

	BROWSEINFO tBrowseInfo;

	tBrowseInfo.hwndOwner      = this->GetSafeHwnd();
	tBrowseInfo.pidlRoot       = NULL;
	tBrowseInfo.pszDisplayName = szDirectoryPath;
	tBrowseInfo.lpszTitle      = "Please select AVI file directory path";
	tBrowseInfo.ulFlags        = BIF_RETURNONLYFSDIRS;
	tBrowseInfo.lpfn           = NULL;
    tBrowseInfo.lParam         = 0;
    tBrowseInfo.iImage         = 0;

	LPITEMIDLIST pItemIDList = SHBrowseForFolder(&tBrowseInfo);
	
	if (pItemIDList == NULL)
	{
        return;
	}

    if (!SHGetPathFromIDList(pItemIDList, szDirectoryPath))
	{
		return;
	}

	strcpy_s(m_pszSaveDirectoryPath, PATHBUF_SIZE, szDirectoryPath);
	
	m_editboxSaveAviFileLocation.SetWindowText(szDirectoryPath);

	// Release ITEMIDLIST use IMalloc interface	
	IMalloc *pIMalloc = NULL;

	if	(SUCCEEDED(SHGetMalloc(&pIMalloc)))
	{
		pIMalloc->Free(pItemIDList);
		
		pIMalloc->Release();
	}
}

LRESULT CConvertAviDlg::OnResetDlgButton(WPARAM, LPARAM)
{
	m_buttonPlay.EnableWindow(TRUE);
	m_buttonStop.EnableWindow(FALSE);
	m_buttonSetupSaveAviFileLocation.EnableWindow(TRUE);

	return 1;
}

// Function     : ReadRawFileThread (Thread)
// Description  : Read data from raw file and input the data to playback channel
// Parameter    : 
//              | [in] lpParam @Parameter passed to the thread
// Return value :
//              | 0 @Success
//              | 1 @Fail
//
DWORD WINAPI ReadRawFileThread(LPVOID lpParam)
{	
	CConvertAviDlg *pDlg = (CConvertAviDlg *)lpParam;

	// Construct a CDataPacketParser object
	CDataPacketParser *pParser = new CDataPacketParser(pDlg->m_strFilePath.GetBuffer());  

	DWORD dwStreamType = pParser->GetMediaStreamType();

	pDlg->m_pAVWrapper->UpdatePlaybackChannelMediaType(dwStreamType);

	TMediaDataPacketInfoV3 tPacketInfo;
	
	SCODE scRet = S_OK;

	while	(!pDlg->m_bStop && (scRet == S_OK))
	{
		// Get one media data packet info form file
		scRet = pParser->GetOneMediaDataPacketInfo(&tPacketInfo);

		// Input the data packet to playback channel
		scRet = pDlg->m_pAVWrapper->InputDataPacketToChannel(&tPacketInfo);

		// Input the data packet to AVI channel
		scRet = pDlg->m_pAVWrapper->InputDataPacketToAVIChannel(&tPacketInfo);

		pParser->EmptyBuffer();
	}

	if	(!pDlg->m_bStop)
	{
		// User does not stop the channel. 
		// Wait until the audio and video elements in AvSynchronizer's queue are all played then stop the channel
		pDlg->m_bStop = TRUE;

		pDlg->m_pAVWrapper->WaitAVQueueEmpty();

		pDlg->m_pAVWrapper->Stop();
		pDlg->m_pAVWrapper->StopAVIChannel();
	}
	else
	{
		// User stop the channel by pressing the stop button.
		pDlg->m_pAVWrapper->Stop();
		pDlg->m_pAVWrapper->StopAVIChannel();
	}

	delete pParser;  // Destroy CDataPacketParser object

	// Reset dialog buttons
	::PostMessage(pDlg->GetSafeHwnd(), WM_USER_RESETDLGBUTTON, 0, 0);

	return 0;
}

// This callback function is used to notify the application the status of the AvSynchronizer, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2)
{
	// Use switch-case to handle different status code
	switch	(dwStatusCode)
	{
	case AVSYNCHRONIZER_STATUSCODE_DECODE_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MEMALLOC_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_FRAME_SIZE_CHG:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_START:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_STOP:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MOTION:
		{
			break;
		}
	case AVSYNCHRONIZER_NEW_IMAGE:
		{
			break;
		}
	case AVSYNCHRONIZER_FIRST_IMAGE:
		{
			break;
		}
	default:
		{
			break;
		}
	}

	return S_OK;
}

// This callback function is used to notify the application before displaying, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo)
{
	HDC hDC = ptDisplayInfo->hDC;

	SetBkMode(hDC, TRANSPARENT);

	SetTextColor(hDC, RGB(255, 255, 255));
	
	// Print time stamp on the top-right of display window	
	if	((ptDisplayInfo->dwFlag & DIF_RESUMING) == 0)
	{
		char szTimeStampBuf[TIMESTAMP_BUF_SIZE] = "\0";

		struct tm *ptmTimeStamp = (struct tm *)ptDisplayInfo->DrawTime;	

		sprintf_s(szTimeStampBuf, TIMESTAMP_BUF_SIZE, "%d/%02d/%02d %02d:%02d:%02d", ptmTimeStamp->tm_year + 1900, 
			                                                                         ptmTimeStamp->tm_mon + 1, 
																				     ptmTimeStamp->tm_mday,
																					 ptmTimeStamp->tm_hour, 
																					 ptmTimeStamp->tm_min, 
																					 ptmTimeStamp->tm_sec);

		SIZE szTimeStampBufSize;

		GetTextExtentPoint32(hDC, szTimeStampBuf, strlen(szTimeStampBuf), &szTimeStampBufSize);

		TextOut(hDC, ptDisplayInfo->dwWidth - szTimeStampBufSize.cx - 5, ptDisplayInfo->ptOrigin.y, szTimeStampBuf, strlen(szTimeStampBuf));
	}

	return S_OK;
}

// This callback function is used to notify the application the status of the AvSynchronizer, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerAviStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2)
{
	switch	(dwStatusCode)
	{
	case AVI_WRITE_FRAME_TIME:
		{
			break;
		}
	default:
		{
			break;
		}
	}

	return S_OK;
}

// This callback function is used to notify the application while AVI conversion proceeding, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerAviCaptionCallBack(DWORD dwContext, TDISPLAYINFO* ptCaptionInfo)
{
	HDC hDC = ptCaptionInfo->hDC;

	SetBkColor(hDC, RGB(0, 0, 0));

	SetTextColor(hDC, RGB(255, 255, 0));
	
	// Print time stamp on the top-right of AVI file	
	if	((ptCaptionInfo->dwFlag & DIF_RESUMING) == 0)
	{
		char szTimeStampBuf[TIMESTAMP_BUF_SIZE] = "\0";

		struct tm *ptmTimeStamp = gmtime((time_t *) &ptCaptionInfo->DrawTime);  // Use gmtime to convert the DrawTime to tm structure!

		sprintf_s(szTimeStampBuf, TIMESTAMP_BUF_SIZE, "%d/%02d/%02d %02d:%02d:%02d", ptmTimeStamp->tm_year + 1900, 
			                                                                         ptmTimeStamp->tm_mon + 1, 
																				     ptmTimeStamp->tm_mday,
																					 ptmTimeStamp->tm_hour, 
																					 ptmTimeStamp->tm_min, 
																					 ptmTimeStamp->tm_sec);

		SIZE szTimeStampBufSize;

		GetTextExtentPoint32(hDC, szTimeStampBuf, strlen(szTimeStampBuf), &szTimeStampBufSize);

		TextOut(hDC, ptCaptionInfo->dwWidth - szTimeStampBufSize.cx - 5, ptCaptionInfo->ptOrigin.y, szTimeStampBuf, strlen(szTimeStampBuf));
	}

	return S_OK;
}
