#ifndef AVSYNCLIVECUSTOMDRAWWRAPPER_H
#define AVSYNCLIVECUSTOMDRAWWRAPPER_H

#include <windows.h>
#include "datapacketdef.h"
#include "AvSynchronizer.h"

#define AV_ERRMSGBUF_SIZE 200  // Error message buffer size 


typedef struct tAvSyncLiveCustomDrawWrapperParam
{
	HWND    hDlg;
	HWND    hDisplay;
	HBITMAP hBMP;

	LPSTATUSCALLBACK  pfStatus;
	LPDISPLAYCALLBACK pfDisplay;
	
	DWORD dwStatusContext;
	DWORD dwDisplayContext;

}TAVSYNCLIVECUSTOMDRAWWRAPPERPARAM;  // Structure : parameters

class CAvSyncLiveCustomDrawWrapper
{
private:
	HANDLE m_hAvSync;       // AvSynchronizer handle
	HANDLE m_hLiveChannel;  // Live channel handle

	char m_szErrMsgBuf[AV_ERRMSGBUF_SIZE];  // Error message buffer

	TAVSYNCLIVECUSTOMDRAWWRAPPERPARAM m_tParam;

	SCODE InitialModule();
	SCODE ReleaseModule();
	SCODE CreateChannel();
	SCODE DeleteChannel();

public:	
	BOOL m_bDrawOnGraph;  // Indicate if the CAPTION_ON_GRAPH flag is set. TRUE: Set, FALSE: Not set

	HBITMAP m_hBanner;  // Bitmap handle of "SAMPLE CODE" banner

	CAvSyncLiveCustomDrawWrapper(HWND hDlg, HWND hDisplay, HBITMAP hBMP, HBITMAP hBanner, LPSTATUSCALLBACK pfStatus, LPDISPLAYCALLBACK pfDisplay, DWORD dwStatusContext, DWORD dwDisplayContext);
	~CAvSyncLiveCustomDrawWrapper();

	SCODE Start();
	SCODE Stop();

	SCODE UpdateChannelMediaType(DWORD dwMediaType);
	SCODE UpdateChannelShowBMP();
	SCODE InputEncodedMediaFrame(TMediaDataPacketInfo *pMediaDataPacket);
};

#endif  // AVSYNCLIVECUSTOMDRAWWRAPPER_H