#ifndef AVSYNCLIVEGETRAWWRAPPER_H
#define AVSYNCLIVEGETRAWWRAPPER_H

#include <windows.h>
#include "datapacketdef.h"
#include "AvSynchronizer.h"

#define AV_ERRMSGBUF_SIZE 200  // Error message buffer size 


typedef struct tAvSyncLiveGetRawWrapperParam
{
	HWND    hDlg;
	HWND    hDisplay;
	HBITMAP hBMP;

	LPSTATUSCALLBACK  pfStatus;
	LPDISPLAYCALLBACK pfDisplay;
	
	DWORD dwStatusContext;
	DWORD dwDisplayContext;

}TAVSYNCLIVEGETRAWWRAPPERPARAM;  // Structure : parameters

class CAvSyncLiveGetRawWrapper
{
private:
	HANDLE m_hAvSync;       // AvSynchronizer handle
	HANDLE m_hLiveChannel;  // Live channel handle

	char m_szErrMsgBuf[AV_ERRMSGBUF_SIZE];  // Error message buffer

	TAVSYNCLIVEGETRAWWRAPPERPARAM m_tParam;

	SCODE InitialModule();
	SCODE ReleaseModule();
	SCODE CreateChannel();
	SCODE DeleteChannel();

public:
	DWORD m_dwDecodeFormat;  // Decode data format

	CAvSyncLiveGetRawWrapper(HWND hDlg, HWND hDisplay, HBITMAP hBMP, LPSTATUSCALLBACK pfStatus, LPDISPLAYCALLBACK pfDisplay, DWORD dwStatusContext, DWORD dwDisplayContext);
	~CAvSyncLiveGetRawWrapper();

	SCODE Start();
	SCODE Stop();

	SCODE UpdateChannelMediaType(DWORD dwMediaType);
	SCODE UpdateChannelShowBMP();
	SCODE InputEncodedMediaFrame(TMediaDataPacketInfo *pMediaDataPacket);
	SCODE SetDecodeOptions(DWORD dwFormat, LPDECODEFRAMECALLBACK_EX pfDecodeFrameEx, DWORD dwDecodeFrameContext);
};

#endif  // AVSYNCLIVEGETRAWWRAPPER_H