// DisplayWithMotionAlertDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DisplayWithMotionAlert.h"
#include "DisplayWithMotionAlertDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#include "DataBrokerConnectWrapper.h"
#include "AvSyncLiveWrapper.h"
#include "SetupConnectionDlg.h"

#define ERRMSGBUF_SIZE     200  // Error message buffer size 
#define TIMESTAMP_BUF_SIZE 200  // Timestamp buffer size

SCODE __stdcall DataBrokerStatusCallBack(DWORD dwContext, TDataBrokerStatusType tStatusType, PVOID pvParam1, PVOID pvParam2);  // DataBroker Status callback function
SCODE __stdcall DataBrokerAVCallBack(DWORD dwContext,TMediaDataPacketInfo *pMediaDataPacket);                                  // DtatBroker AV callback function
SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2);             // AvSynchronizer Status callback function
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo);                                   // AvSynchronizer Display callback function


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CDisplayWithMotionAlertDlg dialog




CDisplayWithMotionAlertDlg::CDisplayWithMotionAlertDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDisplayWithMotionAlertDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDisplayWithMotionAlertDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_HOSTIPADDRESS, m_editboxHostIPAddress);
	DDX_Control(pDX, IDC_EDIT_SERVERTYPE, m_editboxServerType);
	DDX_Control(pDX, IDC_EDIT_PORT, m_editboxPort);
	DDX_Control(pDX, IDC_BUTTON_START, m_buttonStart);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_buttonStop);
	DDX_Control(pDX, IDC_BUTTON_SETUPCONNECTION, m_buttonSetupconnection);
	DDX_Control(pDX, IDC_CHECK_ENABLEMOTIONDETECTION, m_chkboxEnableMotionDetection);
	DDX_Control(pDX, IDC_BUTTON_APPLY, m_buttonApply);
	DDX_Control(pDX, IDC_CHECK_MOTIONRECTCOLORRED, m_chkboxMotionRectColorRed);
	DDX_Control(pDX, IDC_CHECK_MOTIONRECTCOLORGREEN, m_chkboxMotionRectColorGreen);
	DDX_Control(pDX, IDC_CHECK_MOTIONRECTCOLORBLUE, m_chkboxMotionRectColorBlue);
	DDX_Control(pDX, IDC_CHECK_MOTIONRECTCOLORGRAY, m_chkboxMotionRectColorGray);
	DDX_Control(pDX, IDC_CHECK_ALERTRECTCOLORRED, m_chkboxAlertRectColorRed);
	DDX_Control(pDX, IDC_CHECK_ALERTRECTCOLORGREEN, m_chkboxAlertRectColorGreen);
	DDX_Control(pDX, IDC_CHECK_ALERTRECTCOLORBLUE, m_chkboxAlertRectColorBlue);
	DDX_Control(pDX, IDC_CHECK_ALERTRECTCOLORGRAY, m_chkboxAlertRectColorGray);
	DDX_Control(pDX, IDC_CHECK_MOTIONRECTCOLORUNVISIBLE, m_chkboxMotionRectColorUnvisible);
}

BEGIN_MESSAGE_MAP(CDisplayWithMotionAlertDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_SETUPCONNECTION, &CDisplayWithMotionAlertDlg::OnBnClickedButtonSetupconnection)
	ON_BN_CLICKED(IDC_BUTTON_START, &CDisplayWithMotionAlertDlg::OnBnClickedButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CDisplayWithMotionAlertDlg::OnBnClickedButtonStop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECK_ENABLEMOTIONDETECTION, &CDisplayWithMotionAlertDlg::OnBnClickedCheckEnablemotiondetection)
	ON_BN_CLICKED(IDC_BUTTON_APPLY, &CDisplayWithMotionAlertDlg::OnBnClickedButtonApply)
	ON_BN_CLICKED(IDC_CHECK_MOTIONRECTCOLORRED, &CDisplayWithMotionAlertDlg::OnBnClickedCheckMotionrectcolorred)
	ON_BN_CLICKED(IDC_CHECK_MOTIONRECTCOLORGREEN, &CDisplayWithMotionAlertDlg::OnBnClickedCheckMotionrectcolorgreen)
	ON_BN_CLICKED(IDC_CHECK_MOTIONRECTCOLORBLUE, &CDisplayWithMotionAlertDlg::OnBnClickedCheckMotionrectcolorblue)
	ON_BN_CLICKED(IDC_CHECK_MOTIONRECTCOLORGRAY, &CDisplayWithMotionAlertDlg::OnBnClickedCheckMotionrectcolorgray)
	ON_BN_CLICKED(IDC_CHECK_ALERTRECTCOLORRED, &CDisplayWithMotionAlertDlg::OnBnClickedCheckAlertrectcolorred)
	ON_BN_CLICKED(IDC_CHECK_ALERTRECTCOLORGREEN, &CDisplayWithMotionAlertDlg::OnBnClickedCheckAlertrectcolorgreen)
	ON_BN_CLICKED(IDC_CHECK_ALERTRECTCOLORBLUE, &CDisplayWithMotionAlertDlg::OnBnClickedCheckAlertrectcolorblue)
	ON_BN_CLICKED(IDC_CHECK_ALERTRECTCOLORGRAY, &CDisplayWithMotionAlertDlg::OnBnClickedCheckAlertrectcolorgray)
	ON_BN_CLICKED(IDC_CHECK_MOTIONRECTCOLORUNVISIBLE, &CDisplayWithMotionAlertDlg::OnBnClickedCheckMotionrectcolorunvisible)
END_MESSAGE_MAP()


// CDisplayWithMotionAlertDlg message handlers

BOOL CDisplayWithMotionAlertDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Initialization (Appended)
	//
	m_buttonStart.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(FALSE);
	m_buttonApply.EnableWindow(FALSE);

	m_dwMotionRectColor = 0;
	m_dwAlertRectColor = 0;
	m_chkboxMotionRectColorGreen.SetCheck(1);
	m_chkboxAlertRectColorRed.SetCheck(1);

	m_hDisplay = GetDlgItem(IDC_STATIC_DISPLAY)->GetSafeHwnd();

	m_hBMP = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_MARK));

	// Construct a CDataBrokerConnectWrapper object
	m_pDBWrapper = new CDataBrokerConnectWrapper(DataBrokerStatusCallBack, DataBrokerAVCallBack, (DWORD)this, (DWORD)this);
	
	// Construct a CAvSyncLiveWrapper object
	m_pAVWrapper = new CAvSyncLiveWrapper(this->GetSafeHwnd(), m_hDisplay, m_hBMP, AvSynchronizerStatusCallBack, AvSynchronizerDisplayCallBack, (DWORD)this, (DWORD)this);  

	InitializeCriticalSection(&m_CS);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDisplayWithMotionAlertDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDisplayWithMotionAlertDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDisplayWithMotionAlertDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CDisplayWithMotionAlertDlg::OnBnClickedButtonSetupconnection()
{
	// Call setup connection modal dialog
	CSetupConnectionDlg scDlg;

	if	(scDlg.DoModal() == IDOK)
	{
		// Get connection info from setup connection modal dialog
		m_strIPAddr     = scDlg.m_strIPAddr;
		m_strServerType = scDlg.m_strServerType;
		m_strHttpPort   = scDlg.m_strHttpPort;
		m_strUserID     = scDlg.m_strUserID;
	    m_strPassword   = scDlg.m_strPassword;
		m_wHttpPort     = (WORD)scDlg.m_dwHttpPort;
		
		// Show IP address, Server type, and port
		m_editboxHostIPAddress.SetWindowText(m_strIPAddr.GetBuffer());
		m_editboxServerType.SetWindowText(m_strServerType.GetBuffer());
		m_editboxPort.SetWindowText(m_strHttpPort.GetBuffer());

		m_buttonStart.EnableWindow(TRUE);
	}
}

void CDisplayWithMotionAlertDlg::OnBnClickedCheckEnablemotiondetection()
{
	if (m_chkboxEnableMotionDetection.GetCheck() == BST_CHECKED)
	{
		m_pAVWrapper->UpdateEnableMotionDetection(TRUE);
		m_buttonApply.EnableWindow(TRUE);
	}
	else
	{
		m_pAVWrapper->UpdateEnableMotionDetection(FALSE);
		m_buttonApply.EnableWindow(FALSE);
	}
}

void CDisplayWithMotionAlertDlg::OnBnClickedButtonApply()
{
	// Modify the motion and alert rectangle color
	m_pAVWrapper->UpdateModifyMotionRectColor(m_dwMotionRectColor, m_dwAlertRectColor);
}

void CDisplayWithMotionAlertDlg::OnBnClickedButtonStart()
{
	m_buttonStart.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(TRUE);
	m_buttonSetupconnection.EnableWindow(FALSE);

	// Start live channel
	m_pAVWrapper->Start();

	// Connect to remote server
	m_pDBWrapper->Connect(m_wHttpPort, m_strIPAddr.GetBuffer(), m_strServerType.GetBuffer(), m_strUserID.GetBuffer(), m_strPassword.GetBuffer());
}

void CDisplayWithMotionAlertDlg::OnBnClickedButtonStop()
{
	m_buttonStart.EnableWindow(TRUE);
	m_buttonStop.EnableWindow(FALSE);
	m_buttonSetupconnection.EnableWindow(TRUE);

	// Stop live channel
	m_pAVWrapper->Stop();

	// Disconnect from remote server
	m_pDBWrapper->Disconnect();
}

void CDisplayWithMotionAlertDlg::OnDestroy()
{
	delete m_pDBWrapper;  // Delete an CDataBrokerConnectWrapper object
	
	delete m_pAVWrapper;  // Delete an CAvSyncLiveWrapper object

	if	(m_hDisplay != NULL)
	{
		::DestroyWindow(m_hDisplay);
	}

	if	(m_hBMP != NULL)
	{
		::DeleteObject(m_hBMP);
	}

	DeleteCriticalSection(&m_CS);

	CDialog::OnDestroy();
}

// This callback function is used to report the status of DataBroker object, the calling convention must be stdcall
SCODE __stdcall DataBrokerStatusCallBack(DWORD dwContext, TDataBrokerStatusType tStatusType, PVOID pvParam1, PVOID pvParam2)
{
	CDisplayWithMotionAlertDlg *pDlg = (CDisplayWithMotionAlertDlg *)dwContext;

	char szErrMsgBuf[ERRMSGBUF_SIZE] = "\0";

	switch	(tStatusType)
	{
	case eOnConnectionInfo:  // DataBroker connection information
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Connect to remote server successfully\n");

			OutputDebugString(szErrMsgBuf);

			PTDataBrokerConnInfo ptDBConnInfo;

			ptDBConnInfo = (PTDataBrokerConnInfo) pvParam1;

			// Update AvSynchronizer live channel settings	
			if	(ptDBConnInfo->dwMediaType == (emtAudio|emtVideo))
			{
				pDlg->m_pAVWrapper->UpdateChannelMediaType(AVSYNCHRONIZER_MEDIATYPE_AUDIO_VIDEO);
			}
			else if	(ptDBConnInfo->dwMediaType == emtVideo)
			{
				pDlg->m_pAVWrapper->UpdateChannelMediaType(AVSYNCHRONIZER_MEDIATYPE_VIDEO_ONLY);
			}
			else
			{
				pDlg->m_pAVWrapper->UpdateChannelMediaType(AVSYNCHRONIZER_MEDIATYPE_AUDIO_ONLY);
			}

			break;
		}
	case eOnAuthFailed:  // Authentication failed
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Authentication failed!\n");

			OutputDebugString(szErrMsgBuf);

			break;
		}
	case eOnStartMediaChannel:  // DataBroker connection begins to receive media stream
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Begins to receive media stream from remote server\n");

			OutputDebugString(szErrMsgBuf);
			
			break;
		}
	case eOnStopped:  // DataBroker Connection stopped
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Disconnect from remote server successfully\n");

			OutputDebugString(szErrMsgBuf);

			// Reset button state in dialog
			pDlg->m_buttonStart.EnableWindow(TRUE);
			pDlg->m_buttonStop.EnableWindow(FALSE);
			pDlg->m_buttonSetupconnection.EnableWindow(TRUE);

			// Show bitmap
			pDlg->m_pAVWrapper->UpdateChannelShowBMP();

			break;
		}
	case eOnServiceUnavailable:  // The connections to remote server already exceed upper limit.
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Connections to remote server already exceed the upper limit!\n");

			OutputDebugString(szErrMsgBuf);

			// Show bitmap
			pDlg->m_pAVWrapper->UpdateChannelShowBMP();

			break;
		}
	default:
		{
			break;
		}
	}

	return S_OK;
}

// This callback function is used to receive audio and video frames, the calling convention must be stdcall
SCODE __stdcall DataBrokerAVCallBack(DWORD dwContext, TMediaDataPacketInfo *pMediaDataPacket)
{
	CDisplayWithMotionAlertDlg *pDlg = (CDisplayWithMotionAlertDlg *)dwContext;

	char szErrMsgBuf[ERRMSGBUF_SIZE] = "\0";

	SCODE scRet;

	EnterCriticalSection(&pDlg->m_CS);  // Enter critical section

	// Input the media data packet into AvSynchronizer live channel
	scRet = pDlg->m_pAVWrapper->InputEncodedMediaFrame(pMediaDataPacket);	

	if	(scRet == AVSYNCHRONIZER_E_QUEUE_FULL)
	{
		sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "AvSynchronizer queue full!\n");

		OutputDebugString(szErrMsgBuf);

		LeaveCriticalSection(&pDlg->m_CS);  // Leave critical section

		return DATABROKER_S_FRAME_NOT_HANDLED;
	}

	LeaveCriticalSection(&pDlg->m_CS);  // Leave critical section

	return S_OK;
}

// This callback function is used to notify the application the status of the AvSynchronizer, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2)
{
	// Use switch-case to handle different status code
	switch	(dwStatusCode)
	{
	case AVSYNCHRONIZER_STATUSCODE_DECODE_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MEMALLOC_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_FRAME_SIZE_CHG:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_START:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_STOP:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MOTION:
		{
			break;
		}
	case AVSYNCHRONIZER_NEW_IMAGE:
		{
			break;
		}
	case AVSYNCHRONIZER_FIRST_IMAGE:
		{
			break;
		}
	default:
		{
			break;
		}
	}

	return S_OK;
}

// This callback function is used to notify the application before displaying, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo)
{	
	HDC hDC = ptDisplayInfo->hDC;

	SetBkMode(hDC, TRANSPARENT);

	SetTextColor(hDC, RGB(255, 255, 255));

	char szTimeStampBuf[TIMESTAMP_BUF_SIZE] = "\0";
	
	if	((ptDisplayInfo->dwFlag & DIF_CONNECTING) == 0)
	{
		// Print timestamp on the top-right of display window	
		if	((ptDisplayInfo->dwFlag & DIF_RESUMING) == 0)
		{
			struct tm *ptmTimeStamp = (struct tm *)ptDisplayInfo->DrawTime;	

			sprintf_s(szTimeStampBuf, TIMESTAMP_BUF_SIZE, "%d/%02d/%02d %02d:%02d:%02d", ptmTimeStamp->tm_year + 1900, 
																						 ptmTimeStamp->tm_mon + 1, 
																						 ptmTimeStamp->tm_mday,
																						 ptmTimeStamp->tm_hour, 
																						 ptmTimeStamp->tm_min, 
																						 ptmTimeStamp->tm_sec);

			SIZE szTimeStampBufSize;

			GetTextExtentPoint32(hDC, szTimeStampBuf, strlen(szTimeStampBuf), &szTimeStampBufSize);

			TextOut(hDC, ptDisplayInfo->dwWidth - szTimeStampBufSize.cx - 5, ptDisplayInfo->ptOrigin.y, szTimeStampBuf, strlen(szTimeStampBuf));
		}
	}
	else
	{
		sprintf_s(szTimeStampBuf, TIMESTAMP_BUF_SIZE, "Connecting...");

		TextOut(hDC, ptDisplayInfo->ptOrigin.x, ptDisplayInfo->ptOrigin.y, szTimeStampBuf, strlen(szTimeStampBuf));
	}
	
	return S_OK;
}

void CDisplayWithMotionAlertDlg::OnBnClickedCheckMotionrectcolorred()
{
	if (m_chkboxMotionRectColorRed.GetCheck() == BST_CHECKED)
	{
		m_dwMotionRectColor = RECT_RED;
		m_chkboxMotionRectColorGreen.SetCheck(0);
		m_chkboxMotionRectColorBlue.SetCheck(0);
		m_chkboxMotionRectColorGray.SetCheck(0);
		m_chkboxMotionRectColorUnvisible.SetCheck(0);
	}	
}

void CDisplayWithMotionAlertDlg::OnBnClickedCheckMotionrectcolorgreen()
{
	if (m_chkboxMotionRectColorGreen.GetCheck() == BST_CHECKED)
	{
		m_dwMotionRectColor = RECT_GREEN;
		m_chkboxMotionRectColorRed.SetCheck(0);
		m_chkboxMotionRectColorBlue.SetCheck(0);
		m_chkboxMotionRectColorGray.SetCheck(0);
		m_chkboxMotionRectColorUnvisible.SetCheck(0);
	}
}

void CDisplayWithMotionAlertDlg::OnBnClickedCheckMotionrectcolorblue()
{
	if (m_chkboxMotionRectColorBlue.GetCheck() == BST_CHECKED)
	{
		m_dwMotionRectColor = RECT_BLUE;
		m_chkboxMotionRectColorRed.SetCheck(0);
		m_chkboxMotionRectColorGreen.SetCheck(0);
		m_chkboxMotionRectColorGray.SetCheck(0);
		m_chkboxMotionRectColorUnvisible.SetCheck(0);
	}
}

void CDisplayWithMotionAlertDlg::OnBnClickedCheckMotionrectcolorgray()
{
	if (m_chkboxMotionRectColorGray.GetCheck() == BST_CHECKED)
	{
		m_dwMotionRectColor = RECT_GRAY;
		m_chkboxMotionRectColorRed.SetCheck(0);
		m_chkboxMotionRectColorGreen.SetCheck(0);
		m_chkboxMotionRectColorBlue.SetCheck(0);
		m_chkboxMotionRectColorUnvisible.SetCheck(0);
	}
}

void CDisplayWithMotionAlertDlg::OnBnClickedCheckMotionrectcolorunvisible()
{
	if (m_chkboxMotionRectColorUnvisible.GetCheck() == BST_CHECKED)
	{
		m_dwMotionRectColor = -1;
		m_chkboxMotionRectColorRed.SetCheck(0);
		m_chkboxMotionRectColorGreen.SetCheck(0);
		m_chkboxMotionRectColorBlue.SetCheck(0);
		m_chkboxMotionRectColorGray.SetCheck(0);
	}
}

void CDisplayWithMotionAlertDlg::OnBnClickedCheckAlertrectcolorred()
{
	if (m_chkboxAlertRectColorRed.GetCheck() == BST_CHECKED)
	{
		m_dwAlertRectColor = RECT_RED;
		m_chkboxAlertRectColorGreen.SetCheck(0);
		m_chkboxAlertRectColorBlue.SetCheck(0);
		m_chkboxAlertRectColorGray.SetCheck(0);
	}	
}

void CDisplayWithMotionAlertDlg::OnBnClickedCheckAlertrectcolorgreen()
{
	if (m_chkboxAlertRectColorGreen.GetCheck() == BST_CHECKED)
	{
		m_dwAlertRectColor = RECT_GREEN;
		m_chkboxAlertRectColorRed.SetCheck(0);
		m_chkboxAlertRectColorBlue.SetCheck(0);
		m_chkboxAlertRectColorGray.SetCheck(0);
	}
}

void CDisplayWithMotionAlertDlg::OnBnClickedCheckAlertrectcolorblue()
{
	if (m_chkboxAlertRectColorBlue.GetCheck() == BST_CHECKED)
	{
		m_dwAlertRectColor = RECT_BLUE;
		m_chkboxAlertRectColorRed.SetCheck(0);
		m_chkboxAlertRectColorGreen.SetCheck(0);
		m_chkboxAlertRectColorGray.SetCheck(0);
	}
}

void CDisplayWithMotionAlertDlg::OnBnClickedCheckAlertrectcolorgray()
{
	if (m_chkboxAlertRectColorGray.GetCheck() == BST_CHECKED)
	{
		m_dwAlertRectColor = RECT_GRAY;
		m_chkboxAlertRectColorRed.SetCheck(0);
		m_chkboxAlertRectColorGreen.SetCheck(0);
		m_chkboxAlertRectColorBlue.SetCheck(0);
	}
}
