// GetRawDataFromDeviceDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetRawDataFromDevice.h"
#include "GetRawDataFromDeviceDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#include "DataBrokerConnectWrapper.h"
#include "AvSyncDecodeWrapper.h"
#include "SetupConnectionDlg.h"

#define ERRMSGBUF_SIZE 200        // Error message buffer size 
#define PATHBUF_SIZE   MAX_PATH  // Max size of decode directory path buffer

SCODE __stdcall DataBrokerStatusCallBack(DWORD dwContext, TDataBrokerStatusType tStatusType, PVOID pvParam1, PVOID pvParam2);  // DataBroker Status callback function
SCODE __stdcall DataBrokerAVCallBack(DWORD dwContext,TMediaDataPacketInfo *pMediaDataPacket);                                  // DtatBroker AV callback function
SCODE __stdcall AvSynchronizerFrameDecodeCallback(DWORD dwContext, TMediaType tFrameType, TFRAMEINFO *tFrameInfo);             // AvSynchronizer Decode Frame callback function


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CGetRawDataFromDeviceDlg dialog




CGetRawDataFromDeviceDlg::CGetRawDataFromDeviceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetRawDataFromDeviceDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGetRawDataFromDeviceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_HOSTIPADDRESS, m_editboxHostIPAddress);
	DDX_Control(pDX, IDC_EDIT_SERVERTYPE, m_editboxServerType);
	DDX_Control(pDX, IDC_EDIT_PORT, m_editboxPort);
	DDX_Control(pDX, IDC_BUTTON_START, m_buttonStart);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_buttonStop);
	DDX_Control(pDX, IDC_BUTTON_SETUPCONNECTION, m_buttonSetupconnection);
	DDX_Control(pDX, IDC_EDIT_SAVEDECODEDATALOCATION, m_editboxSaveDecodeDataLocation);
	DDX_Control(pDX, IDC_BUTTON_SETUPDECODEDATALOCATION, m_buttonSetupDecodeDataLocation);
	DDX_Control(pDX, IDC_CHECK_USERGB, m_chkboxUseRGB);
	DDX_Control(pDX, IDC_CHECK_USEYUV, m_chkboxUseYUV);
}

BEGIN_MESSAGE_MAP(CGetRawDataFromDeviceDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_SETUPCONNECTION, &CGetRawDataFromDeviceDlg::OnBnClickedButtonSetupconnection)
	ON_BN_CLICKED(IDC_BUTTON_START, &CGetRawDataFromDeviceDlg::OnBnClickedButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CGetRawDataFromDeviceDlg::OnBnClickedButtonStop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECK_USERGB, &CGetRawDataFromDeviceDlg::OnBnClickedCheckUsergb)
	ON_BN_CLICKED(IDC_CHECK_USEYUV, &CGetRawDataFromDeviceDlg::OnBnClickedCheckUseyuv)
	ON_BN_CLICKED(IDC_BUTTON_SETUPDECODEDATALOCATION, &CGetRawDataFromDeviceDlg::OnBnClickedButtonSetupdecodedatalocation)
END_MESSAGE_MAP()


// CGetRawDataFromDeviceDlg message handlers

BOOL CGetRawDataFromDeviceDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Initialization (Appended)
	//
	m_buttonStart.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(FALSE);
	m_chkboxUseYUV.SetCheck(BST_CHECKED);

	m_pszSaveDirectoryPath = new char [PATHBUF_SIZE];
	
	memset(m_pszSaveDirectoryPath, 0, PATHBUF_SIZE);

	// Construct a CDataBrokerConnectWrapper object
	m_pDBWrapper = new CDataBrokerConnectWrapper(DataBrokerStatusCallBack, DataBrokerAVCallBack, (DWORD)this, (DWORD)this);  // Construct a CDataBrokerConnectWrapper object
	
	// Construct a CAvSyncDecodeWrapper object
	m_pAVWrapper = new CAvSyncDecodeWrapper(AvSynchronizerFrameDecodeCallback, (DWORD)this);

	InitializeCriticalSection(&m_CS);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGetRawDataFromDeviceDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGetRawDataFromDeviceDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGetRawDataFromDeviceDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CGetRawDataFromDeviceDlg::OnBnClickedButtonSetupconnection()
{
	// Call setup connection modal dialog
	CSetupConnectionDlg scDlg;

	if	(scDlg.DoModal() == IDOK)
	{
		// Get connection info from setup connection modal dialog
		m_strIPAddr     = scDlg.m_strIPAddr;
		m_strServerType = scDlg.m_strServerType;
		m_strHttpPort   = scDlg.m_strHttpPort;
		m_strUserID     = scDlg.m_strUserID;
	    m_strPassword   = scDlg.m_strPassword;
		m_wHttpPort     = (WORD)scDlg.m_dwHttpPort;
		
		// Show IP address, Server type, and port
		m_editboxHostIPAddress.SetWindowText(m_strIPAddr.GetBuffer());
		m_editboxServerType.SetWindowText(m_strServerType.GetBuffer());
		m_editboxPort.SetWindowText(m_strHttpPort.GetBuffer());

		m_buttonStart.EnableWindow(TRUE);
	}
}

void CGetRawDataFromDeviceDlg::OnBnClickedButtonStart()
{
	if	(m_chkboxUseRGB.GetCheck() == BST_CHECKED)
	{
		m_pAVWrapper->SetDecodeFormat(PF_RGB24);
	}
	else if	(m_chkboxUseYUV.GetCheck() == BST_CHECKED)
	{
		m_pAVWrapper->SetDecodeFormat(PF_YUV);
	}
	else
	{
		return;
	}
	
	m_buttonStart.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(TRUE);
	m_buttonSetupconnection.EnableWindow(FALSE);
	m_chkboxUseRGB.EnableWindow(FALSE);
	m_chkboxUseYUV.EnableWindow(FALSE);

	// Connect to remote server
	m_pDBWrapper->Connect(m_wHttpPort, m_strIPAddr.GetBuffer(), m_strServerType.GetBuffer(), m_strUserID.GetBuffer(), m_strPassword.GetBuffer());
}

void CGetRawDataFromDeviceDlg::OnBnClickedButtonStop()
{
	m_buttonStart.EnableWindow(TRUE);
	m_buttonStop.EnableWindow(FALSE);
	m_buttonSetupconnection.EnableWindow(TRUE);
	m_chkboxUseRGB.EnableWindow(TRUE);
	m_chkboxUseYUV.EnableWindow(TRUE);

	// Disconnect from remote server
	m_pDBWrapper->Disconnect();
}

void CGetRawDataFromDeviceDlg::OnBnClickedCheckUsergb()
{
	if	(m_chkboxUseRGB.GetCheck() == BST_CHECKED)
	{
		m_chkboxUseYUV.SetCheck(BST_UNCHECKED);
	}
	else
	{
		m_chkboxUseYUV.SetCheck(BST_CHECKED);
	}
}

void CGetRawDataFromDeviceDlg::OnBnClickedCheckUseyuv()
{
	if	(m_chkboxUseYUV.GetCheck() == BST_CHECKED)
	{
		m_chkboxUseRGB.SetCheck(BST_UNCHECKED);
	}
	else
	{
		m_chkboxUseRGB.SetCheck(BST_CHECKED);
	}
}

void CGetRawDataFromDeviceDlg::OnBnClickedButtonSetupdecodedatalocation()
{
	char szDirectoryPath[PATHBUF_SIZE] = "\0";

	BROWSEINFO tBrowseInfo;

	tBrowseInfo.hwndOwner      = this->GetSafeHwnd();
	tBrowseInfo.pidlRoot       = NULL;
	tBrowseInfo.pszDisplayName = szDirectoryPath;
	tBrowseInfo.lpszTitle      = "Please select decode directory path";
	tBrowseInfo.ulFlags        = BIF_RETURNONLYFSDIRS;
	tBrowseInfo.lpfn           = NULL;
    tBrowseInfo.lParam         = 0;
    tBrowseInfo.iImage         = 0;

	LPITEMIDLIST pItemIDList = SHBrowseForFolder(&tBrowseInfo);
	
	if (pItemIDList == NULL)
	{
        return;
	}

    if (!SHGetPathFromIDList(pItemIDList, szDirectoryPath))
	{
		return;
	}

	strcpy_s(m_pszSaveDirectoryPath, PATHBUF_SIZE, szDirectoryPath);
	
	m_editboxSaveDecodeDataLocation.SetWindowText(szDirectoryPath);

	// Release ITEMIDLIST use IMalloc interface	
	IMalloc *pIMalloc = NULL;

	if	(SUCCEEDED(SHGetMalloc(&pIMalloc)))
	{
		pIMalloc->Free(pItemIDList);
		
		pIMalloc->Release();
	}
}

void CGetRawDataFromDeviceDlg::OnDestroy()
{
	delete m_pDBWrapper;  // Delete an CDataBrokerConnectWrapper object
	
	delete m_pAVWrapper;  // Delete an CAvSyncDecodeWrapper object

	delete [] m_pszSaveDirectoryPath;

	DeleteCriticalSection(&m_CS);

	CDialog::OnDestroy();
}

// This callback function is used to report the status of DataBroker object, the calling convention must be stdcall
SCODE __stdcall DataBrokerStatusCallBack(DWORD dwContext, TDataBrokerStatusType tStatusType, PVOID pvParam1, PVOID pvParam2)
{
	CGetRawDataFromDeviceDlg *pDlg = (CGetRawDataFromDeviceDlg *)dwContext;

	char szErrMsgBuf[ERRMSGBUF_SIZE] = "\0";

	switch	(tStatusType)
	{
	case eOnConnectionInfo:  // DataBroker connection information
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Connect to remote server successfully\n");

			OutputDebugString(szErrMsgBuf);

			break;
		}
	case eOnAuthFailed:  // Authentication failed
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Authentication failed!\n");

			OutputDebugString(szErrMsgBuf);

			break;
		}
	case eOnStartMediaChannel:  // DataBroker connection begins to receive media stream
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Begins to receive media stream from remote server\n");

			OutputDebugString(szErrMsgBuf);
			
			break;
		}
	case eOnStopped:  // DataBroker Connection stopped
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Disconnect from remote server successfully\n");

			OutputDebugString(szErrMsgBuf);

			// Reset button state in dialog
			pDlg->m_buttonStart.EnableWindow(TRUE);
			pDlg->m_buttonStop.EnableWindow(FALSE);
			pDlg->m_buttonSetupconnection.EnableWindow(TRUE);

			break;
		}
	case eOnServiceUnavailable:  // The connections to remote server already exceed upper limit.
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Connections to remote server already exceed the upper limit!\n");

			OutputDebugString(szErrMsgBuf);

			break;
		}
	default:
		{
			break;
		}
	}

	return S_OK;
}

// This callback function is used to receive audio and video frames, the calling convention must be stdcall
SCODE __stdcall DataBrokerAVCallBack(DWORD dwContext, TMediaDataPacketInfo *pMediaDataPacket)
{
	CGetRawDataFromDeviceDlg *pDlg = (CGetRawDataFromDeviceDlg *)dwContext;

	EnterCriticalSection(&pDlg->m_CS);  // Enter critical section

	// Input the media data packet into AvSynchronizer decoder channel
	pDlg->m_pAVWrapper->InputToBeDecodedMediaFrame(pMediaDataPacket);

	LeaveCriticalSection(&pDlg->m_CS);  // Leave critical section

	return S_OK;
}

// This callback function is used to notify the application the decoded audio or video frame, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerFrameDecodeCallback(DWORD dwContext, TMediaType tFrameType, TFRAMEINFO *tFrameInfo)
{
	CGetRawDataFromDeviceDlg *pDlg = (CGetRawDataFromDeviceDlg *)dwContext;
	
	FILE *pRawVideoFile = NULL;
	FILE *pRawAudioFile = NULL;

	char szFilePathBuf[PATHBUF_SIZE] = "\0";

	EPIXELFORMAT ePixelFormat = EPIXELFORMAT(pDlg->m_pAVWrapper->m_dwDecodeFormat);

	if	(tFrameType == AVSYNCHRONIZER_MEDIATYPE_VIDEO_ONLY)  // Save video raw data
	{
		switch	(ePixelFormat)
		{
		case PF_RGB24:
			{
				sprintf_s(szFilePathBuf, PATHBUF_SIZE, "%s\\Decode Video.pcm", pDlg->m_pszSaveDirectoryPath);

				break;
			}
		case PF_YUV:
			{
				sprintf_s(szFilePathBuf, PATHBUF_SIZE, "%s\\Decode Video.yuv", pDlg->m_pszSaveDirectoryPath);

				break;
			}
		default:
			{
				break;
			}
		}

		fopen_s(&pRawVideoFile, szFilePathBuf, "ab");

		if	(pRawVideoFile != NULL)
		{
			fwrite(tFrameInfo->tVideoFrame.pbyPicture, sizeof(BYTE), tFrameInfo->tVideoFrame.dwSize, pRawVideoFile);

			fclose(pRawVideoFile);
		}
	}
	else if	(tFrameType == AVSYNCHRONIZER_MEDIATYPE_AUDIO_ONLY)  // Save audio raw data
	{
		sprintf_s(szFilePathBuf, PATHBUF_SIZE, "%s\\Decode Audio.pcm", pDlg->m_pszSaveDirectoryPath);

		fopen_s(&pRawAudioFile, szFilePathBuf, "ab");

		if	(pRawAudioFile != NULL)
		{
			fwrite(tFrameInfo->tAudioFrame.pbySound, sizeof(BYTE), tFrameInfo->tAudioFrame.dwSize, pRawAudioFile);

			fclose(pRawAudioFile);
		}
	}

	return S_OK;
}