// PlayRawFileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PlayRawFile.h"
#include "PlayRawFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#include "datapacketdef.h"
#include "parsedatapacket.h"
#include "AvSyncPlaybackWrapper.h"
#include "DataPacketParser.h"

#define MAX_PLAYSPEED_COUNT 3    // Max count of multiples/divisors of play speed
#define TIMESTAMP_BUF_SIZE  200  // Timestamp buffer size


DWORD WINAPI ReadRawFileThread(LPVOID lpParam);  // Read raw file thread

SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2);  // AvSynchronizer Status callback function
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo);                        // AvSynchronizer Display callback function


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CPlayRawFileDlg dialog




CPlayRawFileDlg::CPlayRawFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPlayRawFileDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPlayRawFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_FILEPATH, m_editboxFilePath);
	DDX_Control(pDX, IDC_BUTTON_PLAY, m_buttonPlay);
	DDX_Control(pDX, IDC_BUTTON_PAUSE, m_buttonPause);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_buttonStop);
	DDX_Control(pDX, IDC_BUTTON_SETPLAYSPEED1, m_buttonSetplayspeed1);
	DDX_Control(pDX, IDC_BUTTON_SETPLAYSPEED2, m_buttonSetplayspeed2);
	DDX_Control(pDX, IDC_BUTTON_SETPLAYSPEEDNORMAL, m_buttonSetplayspeednormal);
	DDX_Control(pDX, IDC_BUTTON_NEXTFRAME, m_buttonNextFrame);
}

BEGIN_MESSAGE_MAP(CPlayRawFileDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_OPENFILE, &CPlayRawFileDlg::OnBnClickedButtonOpenfile)
	ON_BN_CLICKED(IDC_BUTTON_PLAY, &CPlayRawFileDlg::OnBnClickedButtonPlay)
	ON_BN_CLICKED(IDC_BUTTON_PAUSE, &CPlayRawFileDlg::OnBnClickedButtonPause)
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CPlayRawFileDlg::OnBnClickedButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_SETPLAYSPEED1, &CPlayRawFileDlg::OnBnClickedButtonSetplayspeed1)
	ON_BN_CLICKED(IDC_BUTTON_SETPLAYSPEED2, &CPlayRawFileDlg::OnBnClickedButtonSetplayspeed2)
	ON_BN_CLICKED(IDC_BUTTON_SETPLAYSPEEDNORMAL, &CPlayRawFileDlg::OnBnClickedButtonSetplayspeednormal)
	ON_BN_CLICKED(IDC_BUTTON_NEXTFRAME, &CPlayRawFileDlg::OnBnClickedButtonNextframe)
	
	ON_MESSAGE(WM_USER_RESETDLGBUTTON, &CPlayRawFileDlg::OnResetDlgButton)  // Specific message map : WM_USER_RESETDLGBUTTON -> OnResetDlgButton
END_MESSAGE_MAP()


// CPlayRawFileDlg message handlers

BOOL CPlayRawFileDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	
	// Initialization (Appended)
	//
	m_bPause = FALSE;
	m_bStop  = FALSE;

	m_dwFastSpeedCount = 0;
	m_dwSlowSpeedCount = 0;
	
	m_hDisplay = GetDlgItem(IDC_STATIC_DISPLAY)->GetSafeHwnd();

	m_hBMP = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_MARK));

	m_hReadRawFileThread = NULL;
	
	// Construct a CAvSyncPlaybackWrapper object
	m_pAVWrapper = new CAvSyncPlaybackWrapper(this->GetSafeHwnd(), m_hDisplay, m_hBMP, AvSynchronizerStatusCallBack, AvSynchronizerDisplayCallBack, (DWORD)this, (DWORD)this); 

	m_buttonPlay.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(FALSE);
	m_buttonPause.EnableWindow(FALSE);
	m_buttonSetplayspeed1.EnableWindow(FALSE);
	m_buttonSetplayspeed2.EnableWindow(FALSE);
	m_buttonSetplayspeednormal.EnableWindow(FALSE);
	m_buttonNextFrame.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPlayRawFileDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPlayRawFileDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPlayRawFileDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CPlayRawFileDlg::OnDestroy()
{
	if	(m_hReadRawFileThread != NULL)
	{	
		// If the playback channel is paused, the thread cannot return
		if	(m_bPause)
		{
			m_pAVWrapper->Pause(FALSE);  // Resume the playback channel
		}

		if	(!m_bStop)
		{	
			m_bStop = TRUE;

			// Wait for the "ReadRawFileThread"
			WaitForSingleObject(m_hReadRawFileThread, INFINITE);
		}

		// Close thread handle
		CloseHandle(m_hReadRawFileThread);
	}
	
	delete m_pAVWrapper;  // Destroy the CAvSyncPlaybackWrapper object

	if	(m_hDisplay != NULL)
	{
		::DestroyWindow(m_hDisplay);
	}

	if	(m_hBMP != NULL)
	{
		::DeleteObject(m_hBMP);
	}
	
	CDialog::OnDestroy();
}

void CPlayRawFileDlg::OnBnClickedButtonOpenfile()
{
	char szFileFilter[] = "All Files (*.*)|*.*||";
	
	CFileDialog fDlg(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFileFilter);

	if	(fDlg.DoModal() == IDOK)
	{
		m_strFilePath = fDlg.GetPathName();

		m_editboxFilePath.SetWindowText(m_strFilePath.GetBuffer());

		m_buttonPlay.EnableWindow(TRUE);
	}
}

void CPlayRawFileDlg::OnBnClickedButtonPlay()
{
	SCODE scRet;
	
	scRet = m_pAVWrapper->Play();  // Play

	if	(scRet != S_OK)
	{
		return;
	}

	m_bStop = FALSE;

	m_hReadRawFileThread = CreateThread(NULL, 0, ReadRawFileThread, this, 0, &m_dwThreadID);  // Start "ReadRawFileThread"
	
	m_buttonPlay.EnableWindow(FALSE);
	m_buttonPause.EnableWindow(TRUE);
	m_buttonStop.EnableWindow(TRUE);
	m_buttonSetplayspeed1.EnableWindow(TRUE);
	m_buttonSetplayspeed2.EnableWindow(TRUE);
	m_buttonSetplayspeednormal.EnableWindow(TRUE);
}

void CPlayRawFileDlg::OnBnClickedButtonPause()
{		
	if	(!m_bPause)  // Pause
	{
		m_buttonPause.SetWindowText("Resume");		
		m_buttonSetplayspeed1.EnableWindow(FALSE);
		m_buttonSetplayspeed2.EnableWindow(FALSE);
		m_buttonSetplayspeednormal.EnableWindow(FALSE);
		m_buttonNextFrame.EnableWindow(TRUE);

		m_bPause = TRUE;

		m_pAVWrapper->Pause(m_bPause);
	}
	else  // Resume
	{
		m_buttonPause.SetWindowText("Pause");
		m_buttonStop.EnableWindow(TRUE);
		m_buttonSetplayspeed1.EnableWindow(TRUE);
		m_buttonSetplayspeed2.EnableWindow(TRUE);
		m_buttonSetplayspeednormal.EnableWindow(TRUE);
		m_buttonNextFrame.EnableWindow(FALSE);

		m_bPause = FALSE;

		m_pAVWrapper->Pause(m_bPause);
	}
}

void CPlayRawFileDlg::OnBnClickedButtonStop()
{
	m_dwFastSpeedCount = 0;
	m_dwSlowSpeedCount = 0;

	m_buttonStop.EnableWindow(FALSE);	
	m_buttonPlay.EnableWindow(TRUE);
	m_buttonPause.EnableWindow(FALSE);	
	m_buttonSetplayspeed1.SetWindowText("Fast >>");
	m_buttonSetplayspeed2.SetWindowText("Slow >>");
	m_buttonSetplayspeed1.EnableWindow(FALSE);
	m_buttonSetplayspeed2.EnableWindow(FALSE);
	m_buttonSetplayspeednormal.EnableWindow(FALSE);

	m_bStop = TRUE;
	
	m_pAVWrapper->Stop();  // Stop

	if	(m_hReadRawFileThread)
	{
		// If the playback channel is paused, the thread cannot return
		if	(m_bPause)
		{
			m_bPause = FALSE;

			m_pAVWrapper->Pause(m_bPause);
		}

		// Wait for the "ReadRawFileThread"
		WaitForSingleObject(m_hReadRawFileThread, INFINITE);
	}
}

// Set play speed faster than normal play speed
void CPlayRawFileDlg::OnBnClickedButtonSetplayspeed1()
{	
	m_dwSlowSpeedCount = 0;

	m_buttonSetplayspeed2.SetWindowText("Slow >>");
	
	m_dwFastSpeedCount++;

	DWORD dwFast = 0;
	DWORD dwSlow = 1;

	if	(m_dwFastSpeedCount <= MAX_PLAYSPEED_COUNT)
	{	
		dwFast = 1 << m_dwFastSpeedCount;

		CString strText;

		strText.Format(_T(">> %dX"), dwFast);

		m_buttonSetplayspeed1.SetWindowText(strText);
		
		m_pAVWrapper->Forward(dwFast, dwSlow);  // Fast forward from 2X to 8X.
	}
	else
	{
		dwSlow = 0;

		m_buttonSetplayspeed1.SetWindowText("Full speed");

		m_pAVWrapper->Forward(dwFast, dwSlow);  // Fast forward in full speed
	}
}

// Set play speed slower than normal play speed
void CPlayRawFileDlg::OnBnClickedButtonSetplayspeed2() 
{
	m_dwFastSpeedCount = 0;

	m_buttonSetplayspeed1.SetWindowText("Fast >>");
	
	m_dwSlowSpeedCount++;

	DWORD dwFast = 1;
	DWORD dwSlow = 0;

	if	(m_dwSlowSpeedCount <= MAX_PLAYSPEED_COUNT)
	{	
		dwSlow = 1 << m_dwSlowSpeedCount;

		CString strText;

		strText.Format(_T(">> 1/%dX"), dwSlow);

		m_buttonSetplayspeed2.SetWindowText(strText);
		
		m_pAVWrapper->Forward(dwFast, dwSlow);  // Slow forward from 0.5X to 0.125X. 
	}
}

void CPlayRawFileDlg::OnBnClickedButtonSetplayspeednormal()
{
	m_dwFastSpeedCount = 0;
	m_dwSlowSpeedCount = 0;

	m_buttonSetplayspeed1.SetWindowText("Fast >>");
	m_buttonSetplayspeed2.SetWindowText("Slow >>");

	DWORD dwNormalPlaySpeed = 1;
	
	DWORD dwFast = dwNormalPlaySpeed;
	DWORD dwSlow = dwNormalPlaySpeed;
	
	m_pAVWrapper->Forward(dwFast, dwSlow);  // Forward 0X. Set play speed to normal
}

void CPlayRawFileDlg::OnBnClickedButtonNextframe()
{
	// Notice! 
	// The playback channel must be paused before perfom "NextFrame"
	m_pAVWrapper->NextFrame();  // NextFrame
}

// Reset button state in dialog
LRESULT CPlayRawFileDlg::OnResetDlgButton(WPARAM, LPARAM)
{
	m_dwFastSpeedCount = 0;
	m_dwSlowSpeedCount = 0;

	m_buttonPlay.EnableWindow(TRUE);

	m_buttonPause.EnableWindow(FALSE);
	m_buttonPause.SetWindowText("Pause");

	m_buttonStop.EnableWindow(FALSE);
	
	m_buttonSetplayspeed1.EnableWindow(FALSE);
	m_buttonSetplayspeed1.SetWindowText("Fast >>");
	
	m_buttonSetplayspeed2.EnableWindow(FALSE);
	m_buttonSetplayspeed2.SetWindowText("Slow >>");
	
	m_buttonSetplayspeednormal.EnableWindow(FALSE);
	
	m_buttonNextFrame.EnableWindow(FALSE);

	return 1;
}

// Function     : ReadRawFileThread (Thread)
// Description  : Read data from raw file and input the data to playback channel
// Parameter    : 
//              | [in] lpParam @Parameter passed to the thread
// Return value :
//              | 0 @Success
//              | 1 @Fail
//
DWORD WINAPI ReadRawFileThread(LPVOID lpParam)
{	
	CPlayRawFileDlg *pDlg = (CPlayRawFileDlg *)lpParam;

	// Construct a CDataPacketParser object
	CDataPacketParser *pParser = new CDataPacketParser(pDlg->m_strFilePath.GetBuffer());  

	DWORD dwStreamType = pParser->GetMediaStreamType();

	pDlg->m_pAVWrapper->UpdatePlaybackChannelMediaType(dwStreamType);

	TMediaDataPacketInfoV3 tPacketInfo;
	
	SCODE scRet = S_OK;

	while	(!pDlg->m_bStop && (scRet == S_OK))
	{
		// Get one media data packet info form file
		scRet = pParser->GetOneMediaDataPacketInfo(&tPacketInfo);		

		// Input the data packet to playback channel
		scRet = pDlg->m_pAVWrapper->InputDataPacketToChannel(&tPacketInfo);

		pParser->EmptyBuffer();
	}

	if	(!pDlg->m_bStop)
	{
		// User does not stop the channel. 
		// Wait until the audio and video elements in AvSynchronizer's queue are all played then stop the channel
		pDlg->m_bStop = TRUE;

		pDlg->m_pAVWrapper->WaitAVQueueEmpty();

		pDlg->m_pAVWrapper->Stop();
	}
	else
	{
		// User stop the channel by pressing the stop button.
		pDlg->m_pAVWrapper->Stop();
	}

	delete pParser;  // Destroy CDataPacketParser object

	// Reset dialog buttons
	::PostMessage(pDlg->GetSafeHwnd(), WM_USER_RESETDLGBUTTON, 0, 0);

	return 0;
}

// This callback function is used to notify the application the status of the AvSynchronizer, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2)
{
	// Use switch-case to handle different status code
	switch	(dwStatusCode)
	{
	case AVSYNCHRONIZER_STATUSCODE_DECODE_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MEMALLOC_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_FRAME_SIZE_CHG:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_START:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_STOP:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MOTION:
		{
			break;
		}
	case AVSYNCHRONIZER_NEW_IMAGE:
		{
			break;
		}
	case AVSYNCHRONIZER_FIRST_IMAGE:
		{
			break;
		}
	default:
		{
			break;
		}
	}

	return S_OK;
}

// This callback function is used to notify the application before displaying, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo)
{
	HDC hDC = ptDisplayInfo->hDC;

	SetBkMode(hDC, TRANSPARENT);

	SetTextColor(hDC, RGB(255, 255, 255));
	
	// Print timestamp on the top-right of display window	
	if	((ptDisplayInfo->dwFlag & DIF_RESUMING) == 0)
	{
		char szTimeStampBuf[TIMESTAMP_BUF_SIZE] = "\0";

		struct tm *ptmTimeStamp = (struct tm *)ptDisplayInfo->DrawTime;	

		sprintf_s(szTimeStampBuf, TIMESTAMP_BUF_SIZE, "%d/%02d/%02d %02d:%02d:%02d", ptmTimeStamp->tm_year + 1900, 
			                                                                         ptmTimeStamp->tm_mon + 1, 
																				     ptmTimeStamp->tm_mday,
																					 ptmTimeStamp->tm_hour, 
																					 ptmTimeStamp->tm_min, 
																					 ptmTimeStamp->tm_sec);

		OutputDebugString(szTimeStampBuf);

		SIZE szTimeStampBufSize;

		GetTextExtentPoint32(hDC, szTimeStampBuf, strlen(szTimeStampBuf), &szTimeStampBufSize);

		TextOut(hDC, ptDisplayInfo->dwWidth - szTimeStampBufSize.cx - 5, ptDisplayInfo->ptOrigin.y, szTimeStampBuf, strlen(szTimeStampBuf));
	}

	return S_OK;
}
